# Generated by Django 5.0.7 on 2024-08-27 13:50

from django.db import migrations

from main.blocks import CandidateBlock


def move_candidate_block_data(apps, schema_editor):
    MainProgramPage = apps.get_model("main", "MainProgramPage")

    for page in MainProgramPage.objects.all():
        for program in page.program:
            if program.block_type != "program_group_with_candidates":
                continue

            candidate_children = program.value["primary_candidates"]["candidates"]

            for candidate_child in candidate_children:
                program.value["primary_candidates"]["stream_candidates"].append(
                    (
                        "candidate",
                        CandidateBlock().to_python(
                            {
                                "page": candidate_child["page"].id,
                                "image": (
                                    candidate_child["image"].id
                                    if candidate_child["image"] is not None
                                    else None
                                ),
                                "description": (
                                    candidate_child["description"].source
                                    if candidate_child["description"] is not None
                                    else None
                                ),
                            }
                        ),
                    )
                )

            program.value["primary_candidates"]["candidates"] = []

        page.save()


class Migration(migrations.Migration):
    dependencies = [
        ("main", "0120_alter_mainprogrampage_program"),
    ]

    operations = [migrations.RunPython(move_candidate_block_data)]
